<script setup lang="ts">
import { getVoteOpenedAt } from '@/scripts/blockchain'
import type { VoteInformation } from '@/scripts/types'
import { useDataStore } from '@/store/data'
import { PropType, reactive, onMounted, watch } from 'vue'
import { onBeforeRouteLeave } from 'vue-router'

const data = useDataStore()

const props = defineProps({
  mode: {
    type: String as PropType<'list-item' | 'info' | 'teller-info'>,
    required: true
  },
  vote: {
    type: Object as PropType<VoteInformation>,
    required: true
  },
  hover: {
    type: Boolean,
    default: false
  }
})

const emit = defineEmits(['click'])

const state = reactive({
  timer: undefined as ReturnType<typeof setInterval> | undefined,
  timeRemaining: undefined as number | undefined,
  openedAt: undefined as number | undefined
})

watch(() => props.vote, async () => {
  if (props.vote.status === 'open') {
    state.openedAt = await getVoteOpenedAt(props.vote.id)
  } else state.openedAt = undefined
})

onMounted(() => {
  state.timer = setInterval(() => {
    if (state.openedAt == null || props.vote == null) {
      state.timeRemaining = undefined
      return
    }
    const now = Date.now() // milliseconds
    const closeAt = state.openedAt + props.vote.duration // milliseconds
    state.timeRemaining = Math.round((closeAt - now) / 1000) // seconds
    if (state.timeRemaining < 0) {
      state.timeRemaining = 0 // waiting for close event
    }
  }, 500)
})

onBeforeRouteLeave((to, from, next) => {
  clearInterval(state.timer)
  next()
})

function click() {
  if (props.hover) {
    emit('click')
  }
}
</script>

<template>
<v-card :variant="hover ? 'tonal' : 'flat'" :color="hover ? 'primary' : 'none'" @click="click" :link="hover">
  <v-card-text><p class="text-xl">{{ vote.title }}</p></v-card-text>

  <v-card-actions v-if="mode==='list-item'">
    <div class="flex grow items-center justify-between flex-col sm:flex-row">
      <v-card-subtitle>#{{ vote.id }}</v-card-subtitle>
      <div class="grow" />

      <v-chip class="mr-3" size="small" label v-if="state.timeRemaining != null && state.timeRemaining === 0" color="primary">Temps écoulé !</v-chip>
      <v-chip class="mr-3" size="small" label v-else-if="state.timeRemaining != null" color="primary">Temps restant: {{ state.timeRemaining }}s</v-chip>
      <v-btn v-if="vote.status==='validated' || vote.status==='archived'" color="success" link :to="`/votes/${vote.id}/results`">Afficher les résultats</v-btn>
      <v-btn v-else-if="vote.status==='open' && data.savedBallots[vote.id] == null && (!state.timeRemaining || state.timeRemaining !== 0)" color="primary" link :to="`/votes/${vote.id}/form`">Voter !</v-btn>
      <v-btn v-else-if="vote.status==='open' && data.savedBallots[vote.id] != null" color="primary" disabled>Déjà voté !</v-btn>
      <v-btn v-else-if="vote.status==='canceled'" disabled>Annulé</v-btn>
      <v-btn v-else-if="vote.status==='closed'" disabled>Calcul des résultats...</v-btn>
      <v-btn v-else disabled>En attente ...</v-btn>
    </div>
  </v-card-actions>

  <v-card-actions v-if="mode==='info' || mode==='teller-info'">
    <!-- will display the remaining time -->
    <div class="flex grow items-center justify-between flex-col sm:flex-row px-4">
      <p class="">#{{ vote.id }}</p>
      <v-chip size="small" label v-if="state.timeRemaining != null" color="primary">Temps restant: {{ state.timeRemaining }}s</v-chip>
    </div>
  </v-card-actions>
</v-card>
</template>
